/*     %W% %G%  */

/**********************************************************************
FILE   : %M%
PURPOSE: SNNS-Kernel Constants
NOTES  : 
AUTHOR : Niels Mache
DATE   : 01.03.90
VERSION : %I%  %G%

 Copyright (c) 1990,1991,1992 by Niels Mache and the SNNS Group

**********************************************************************/


#ifndef KR_CONSTANTS

#define KR_CONSTANTS

/*  Flag Modifier:

		   |------------------------------ Direct Link Flag
		   |  |--------------------------- Site Flag
		   |  |  |------------------------ |
		   |  |  |  |--------------------- | Topologic Type Flags
		   |  |  |  |  |------------------ |
		   |  |  |  |  |  |--------------- |
		   |  |  |  |  |  |  |------------ Refresh Flag
		   |  |  |  |  |  |  |	|--------- Enable Flag
		   |  |  |  |  |  |  |	|  |------ In-Use Flag
		   |  |  |  |  |  |  |	|  |  |--- Allocation Flag

15 14 13 12 11 10  9  8  7  6  5  4  3  2  1  0
-----------------------------------------------
                                           0  0  : Unit is free and may be allocated
                                           0  1  : Unit is now allocated, but not ready to use
                                           1  0  : -- NOT USED --
                                           1  1  : Unit is allocated and ready to use

                                        0 -----  : Unit is freezed
                                        1 -----  : Unit is active (will be updated during next cycle)

                                     0 --------  : Unit is not updated now
                                     1 --------  : Unit is currently updated

			 0  0  0  0 -----------  : Unknown topologic type
			 0  0  0  1 -----------  : Input type
			 0  0  1  0 -----------  : Output type
			 0  0  1  1 -----------  : Dual type (input and output)
			 0  1  0  0 -----------  : Hidden type
			 1  0  0  0 -----------  : Special type (no weight adjustment of input links)

		   0  0 -----------------------  : Unit has no inputs (no links and no Sites)
		   0  1 -----------------------  : Unit has at least one site (and no direct wired inputs)
		   1  0 -----------------------  : Unit has direct input links (and no sites)
		   1  1 -----------------------  : -- NOT USED --

*/

#define  UFLAG_FREE	 0x0000
#define  UFLAG_NOT_FREE  0x0001
#define  UFLAG_IN_USE	 0x0003

#define  UFLAG_INITIALIZED   0x0007
#define  UFLAG_ENABLED	 0x0004

#define  UFLAG_REFRESH	 0x0008

#define  UFLAG_TTYP_PAT  0x00f0
#define  UFLAG_TTYP_UNKN 0x0000
#define  UFLAG_TTYP_IN	 0x0010
#define  UFLAG_TTYP_OUT  0x0020
#define  UFLAG_TTYP_DUAL 0x0030
#define  UFLAG_TTYP_HIDD 0x0040
#define  UFLAG_TTYP_SPEC 0x0080


#define  UFLAG_INPUT_PAT 0x0300
#define  UFLAG_NO_INP	 0x0000
#define  UFLAG_SITES	 0x0100
#define  UFLAG_DLINKS	 0x0200


/*  topologic sorting modes
*/

#define  NOT_SORTED	 0
#define  TOPOLOGICAL	 1
#define  TOPOLOGICAL_FF  2
#define  TOPOLOGIC_TYPE  3
#define  PERMUTATION	 4

#endif
