/*     %W% %G%  */

/**********************************************************************
FILE   : %M%
PURPOSE: SNNS-Kernel Defaults
NOTES  : 
AUTHOR : Niels Mache
DATE   : 01.03.90
VERSION : %I%  %G%

 Copyright (c) 1990,1991,1992 by Niels Mache and the SNNS Group

**********************************************************************/

#ifndef KR_DEFAULTS

#define KR_DEFAULTS

#ifndef NULL
#include <stdio.h>	/*  include "stdio.h" if the NULL-pointer isn't
			    defined  */
#endif


/*  default constants for block memory allocation in # of components
*/
#define  UNIT_BLOCK     1000
#define  LINK_BLOCK     5000
#define  SITE_BLOCK     200
#define  NTABLE_BLOCK   500
#define  STABLE_BLOCK   200
#define  PATTERN_BLOCK  50


/*  Unit/Site Default Initialisations
*/

#define     DEF_OUT         0
#define     DEF_I_ACT       0
#define     DEF_BIAS        0

/*  The unit output identity function is the NULL pointer
*/
#define     OUT_IDENTITY    NULL
#define     DEF_UFUNC_OUT   OUT_IDENTITY

#define     DEF_UFUNC_ACT   ACT_Logistic
FlintType   DEF_UFUNC_ACT ();

#define     DEF_UFUNC_ACT_DERIV  ACT_DERIV_Logistic
FlintType   DEF_UFUNC_ACT_DERIV ();

#define     DEF_SUBNET_NO   0
#define     DEF_LAYER_NO    1
#define     DEF_POS_X       0
#define     DEF_POS_Y       0
#ifdef KERNEL3D
#define     DEF_POS_Z       0
#endif

#define     DEF_STYPE       UFLAG_TTYP_HIDD

#define     DEF_SFUNC       SITE_WeightedSum
FlintType   DEF_SFUNC ();

#define     DEF_LEARN_FUNC  LEARN_backprop
krui_err    DEF_LEARN_FUNC  ();

#define     DEF_UPDATE_FUNC  UPDATE_serialPropagate
krui_err    DEF_UPDATE_FUNC  ();

#define     DEF_INIT_FUNC  INIT_randomizeWeights
krui_err    DEF_INIT_FUNC  ();


/*#################################################

GROUP: File I/O Constants

#################################################*/

/*  max. line length for the kernel input/output files
*/
#define  MAX_LIN_LEN    250
#define  BEST_LINE_LEN  132



#endif
