/*     %W% %G%  */

/**********************************************************************
FILE   : %M%
PURPOSE: SNNS-Kernel: Management routines for user functions
NOTES  : 
AUTHOR : Niels Mache
DATE   : 12.02.90
VERSION : %I%  %G%

 Copyright (c) 1990,1991,1992 by Niels Mache and the SNNS Group

**********************************************************************/

#include "kr_typ.h"         /*  Kernel Types and Constants  */
#include "kr_def.h"	    /*	Default Values	*/
#include "kr_funcs.h"       /*  Function Prototypes  */


/**********************************************************************
   This is the Function Table (Function Table may be modified by the user)
**********************************************************************/

extern struct FuncTable  func_table[];
extern int  NO_OF_FUNCS;

/**********************************************************************
   End of Function Table
**********************************************************************/



/*  Returns the number of functions in the function table
*/
int     krf_getNoOfFuncs()
{
  return( NO_OF_FUNCS );
}


/*  returns a pointer to the given function table entry
*/
struct FuncTable   *krf_getFuncTableEntry( func_no )
int     func_no;
{
  return( func_table + (func_no - 1) );
}


/*  seaches for the given function (name and type) and returns a pointer to
    this function. krf_funcSearch(...) returns TRUE if the given function was
    found, FALSE otherwise.
*/
bool    krf_funcSearch( func_name, func_type, func_ptr)
char *func_name;
int  func_type;
FunctionPtr   *func_ptr;
{
  int   i;
  struct FuncTable   *fl_ptr;


  for (i = 0, fl_ptr = func_table; i < NO_OF_FUNCS; i++, fl_ptr++)
    {
    if ( (fl_ptr->func_type == (short) func_type)  &&
         (strcmp( func_name, fl_ptr->func_name ) == 0) )
      {
      *func_ptr = fl_ptr->function;
      return( TRUE );
      }
    }

  return( FALSE );
}


/*  returns a pointer to the function table entry, if the given function
    was found.
    Returns a NULL pointer otherwise.
*/
struct FuncTable   *krf_getFuncTblPtr( func_name, func_type )
char *func_name;
int  func_type;
{
  int   i;
  struct FuncTable   *fl_ptr;


  for (i = 0, fl_ptr = func_table; i < NO_OF_FUNCS; i++, fl_ptr++)
    if ( (fl_ptr->func_type == (short) func_type)  &&
         (strcmp( func_name, fl_ptr->func_name ) == 0) )
      return( fl_ptr );

  return( NULL );
}




/*  Returns the name of the given function
*/
char  *krf_getFuncName( func_ptr )
FunctionPtr func_ptr;
{
  int   i;
  struct FuncTable   *fl_ptr;

  for (i = 0, fl_ptr = func_table; i < NO_OF_FUNCS; i++, fl_ptr++)
    {
    if ( fl_ptr->function == func_ptr)
      return( fl_ptr->func_name );
    }

  return( NULL );
}
