/*     %W% %G%  */

/**********************************************************************
FILE   : %M%
PURPOSE: SNNS-Kernel: Routines for User-Function Management
		      (Function Prototypes)
NOTES  : 
AUTHOR : Niels Mache
DATE   : 12.02.90
VERSION : %I%  %G%

 Copyright (c) 1990,1991,1992 by Niels Mache and the SNNS Group

**********************************************************************/

#ifdef __STDC__

/*  Returns the number of functions in the function table
*/
int krf_getNoOfFuncs( void );

/*  returns a pointer to the given function table entry
*/
struct FuncTable *krf_getFuncTableEntry( int  func_no );

/*  seaches for the given function (name and type) and returns a pointer to
    this function. krf_funcSearch(...) returns TRUE if the given function was
    found, FALSE otherwise.
*/
int krf_funcSearch( char *func_name, int  func_type, FunctionPtr  *func_ptr );

/*  returns a pointer to the function table entry, if the given function
    was found.
    Returns a NULL pointer otherwise.
*/
struct FuncTable *krf_getFuncTblPtr( char *func_name, int  func_type );

/*  Returns the name of the given function
*/
char *krf_getFuncName( FunctionPtr func_ptr );

#else

int krf_getNoOfFuncs();
struct FuncTable *krf_getFuncTableEntry();
int krf_funcSearch();
struct FuncTable *krf_getFuncTblPtr();
char *krf_getFuncName();

#endif
