/*     %W% %G%  */

/**********************************************************************
FILE   : %M%
PURPOSE: SNNS-Kernel User Interface Function Prototypes
NOTES  : 
AUTHOR : Niels Mache
DATE   : 27.02.90
VERSION : %I%  %G%

 Copyright (c) 1990,1991,1992 by Niels Mache and the SNNS Group

**********************************************************************/

#ifdef __STDC__

#include "krui_typ.h"	/*  Interface function prototypes  */

#else

int krui_getNoOfUnits();
int krui_getFirstUnit();
int krui_getNextUnit();
int krui_getCurrentUnit();
int krui_setCurrentUnit();
char *krui_getUnitName();
int krui_setUnitName();
int krui_searchUnitName();
int krui_searchNextUnitName();
char *krui_getUnitOutFuncName();
int krui_setUnitOutFunc();
char *krui_getUnitActFuncName();
int krui_setUnitActFunc();
char *krui_getUnitFTypeName();
float krui_getUnitActivation();
void krui_setUnitActivation();
float krui_getUnitInitialActivation();
void krui_setUnitInitialActivation();
float krui_getUnitOutput();
int krui_setUnitOutput();
float krui_getUnitBias();
void krui_setUnitBias();
int krui_getUnitSubnetNo();
void krui_setUnitSubnetNo();
unsigned short krui_getUnitLayerNo();
void krui_setUnitLayerNo();
void krui_getUnitPosition();
void krui_setUnitPosition();
int krui_getUnitNoAtPosition();
int krui_getUnitNoNearPosition();
int krui_getUnitTType();
int krui_setUnitTType();
void krui_freezeUnit();
void krui_unfreezeUnit();
int krui_isUnitFrozen();
int krui_getUnitInputType();
int krui_createDefaultUnit();
int krui_createUnit();
int krui_deleteUnit();
int krui_createFTypeUnit();
int krui_setUnitFType();
int krui_copyUnit();
int krui_setFirstFTypeEntry();
int krui_setNextFTypeEntry();
int krui_setFTypeEntry();
char *krui_getFTypeName();
int krui_setFTypeName();
char *krui_getFTypeActFuncName();
int krui_setFTypeActFunc();
char *krui_getFTypeOutFuncName();
int krui_setFTypeOutFunc();
int krui_setFirstFTypeSite();
int krui_setNextFTypeSite();
char *krui_getFTypeSiteName();
int krui_setFTypeSiteName();
int krui_createFTypeEntry();
int krui_deleteFTypeEntry();
int krui_getNoOfFunctions();
void krui_getFuncInfo();
int krui_isFunction();
int krui_getFirstSiteTableEntry();
int krui_getNextSiteTableEntry();
char *krui_getSiteTableFuncName();
int krui_createSiteTableEntry();
int krui_changeSiteTableEntry();
int krui_deleteSiteTableEntry();
int krui_setFirstSite();
int krui_setNextSite();
int krui_setSite();
float krui_getSiteValue();
char *krui_getSiteName();
int krui_setSiteName();
char *krui_getSiteFuncName();
int krui_addSite();
int krui_deleteSite();
int krui_getFirstPredUnit();
int krui_getNextPredUnit();
int krui_getCurrentPredUnit();
int krui_getFirstSuccUnit();
int krui_getNextSuccUnit();
int krui_getCurrentSuccUnit();
int krui_isConnected();
int krui_areConnected();
float krui_getLinkWeight();
void krui_setLinkWeight();
int krui_createLink();
void krui_deleteLink();
void krui_deleteAllInputLinks();
void krui_deleteAllOutputLinks();

void krui_jogWeights();
char  *krui_getUpdateFunc();
int  krui_setUpdateFunc();
int krui_updateSingleUnit();
int krui_updateNet();
int krui_testNet();

char  *krui_getInitialisationFunc();
int   krui_setInitialisationFunc();
int   krui_initializeNet();

char *krui_getLearnFunc();
int krui_setLearnFunc();
int krui_learnAllPatterns();
int krui_learnSinglePattern();

int krui_showPattern();
int krui_newPattern();
int krui_setPatternNo();
int krui_deletePattern();
int krui_modifyPattern();
void krui_deleteAllPatterns();
int krui_shufflePatterns();

int krui_saveNet();
int krui_loadNet();
int krui_loadPatterns();
int krui_savePatterns();
int krui_allocateUnits();
void krui_deleteNet();
int krui_getFirstSymbolTableEntry();
int krui_getNextSymbolTableEntry();
int krui_symbolSearch();
char *krui_getVersion();
void krui_getNetInfo();
void krui_getMemoryManagerInfo();
void krui_getUnitDefaults();
int krui_setUnitDefaults();
void krui_resetNet();
void krui_setSeedNo();
int krui_getNoOfInputUnits();
int krui_getNoOfOutputUnits();
int krui_getNoOfTTypeUnits();
int krui_getNoOfPatterns();

int krui_getXYTransTable();
int krui_getUnitCenters();
int krui_setUnitCenters();

char *krui_error();

#endif
